/*
*  Copyright 2019-2025 Tz
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*  http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*/
package me.zhengjie.modules.system.service;

import java.util.List;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import me.zhengjie.modules.front.domain.dto.DeviceLogCriteria;
import me.zhengjie.modules.security.config.enums.CurrentStatusEnum;
import me.zhengjie.modules.security.config.enums.ErrorStatusEnum;
import me.zhengjie.modules.security.config.enums.PrintInfoStatusEnum;
import me.zhengjie.modules.system.domain.BusCommandLog;
import me.zhengjie.modules.system.domain.BusDevice;
import me.zhengjie.modules.system.domain.Menu;
import me.zhengjie.modules.system.domain.dto.BusDeviceQueryCriteria;
import me.zhengjie.modules.system.domain.dto.BusTreeVo;
import me.zhengjie.utils.PageResult;

/**
* @description 服务接口
* @author tz
* @date 2025-05-20
**/
public interface BusDeviceService extends IService<BusDevice> {

    BusDevice getByDeviceSn(String deviceSn);

    /**
     * 修改设备状态
     */
    void updateDeviceStatus(String deviceSn, CurrentStatusEnum e1, PrintInfoStatusEnum e2, ErrorStatusEnum e3, String remark);

    PageResult<BusDevice> myDeviceList(Long userId, Page<Object> page);

    /**
    * 查询数据分页
    * @param criteria 条件
    * @param page 分页参数
    * @return PageResult
    */
    PageResult<BusDevice> queryAll(BusDeviceQueryCriteria criteria, Page<Object> page);

    /**
    * 查询所有数据不分页
    * @param criteria 条件参数
    * @return List<BusDeviceDto>
    */
    List<BusDevice> queryAll(BusDeviceQueryCriteria criteria);

    /**
    * 创建
    * @param resources /
    */
    void create(BusDevice resources);

    /**
    * 编辑
    * @param resources /
    */
    void update(BusDevice resources);

    /**
    * 多选删除
    * @param ids /
    */
    void deleteAll(List<Long> ids);

    String getQrCode(Long id);

    void bindingDevice(String code);

    List<BusTreeVo> getDeviceTree(Long pid);

    void updateOrAdd(BusDevice entity);

    BusDevice getByDeviceCode(String deviceCode);

    PageResult<BusCommandLog> deviceLogList(DeviceLogCriteria criteria, Page<Object> page);

}